#!/bin/sh
#
# ================================================================
# Licensed Material - Property of IBM
# 5655-P28 Copyright IBM Corp. 2006, 2011
#
# All Rights Reserved.
#
# U.S. Government users - RESTRICTED RIGHTS - Use, Duplication, or
# Disclosure restricted by GSA-ADP schedule contract with IBM Corp.
#
#                                                  
# ================================================================
#
# This script upgrades XD 61 to VE700
# usage: <name>.sh <install hfs location> <configuration hfs location
#
 
if [ -z $1 ]
then
   echo "Usage Syntax: ${0} <install hfs location> <(Writable) configuration hfs location> <userid> <password>"   
   exit 0
fi
 
if [ -z $2 ]
then
   echo "Usage Syntax: ${0} <install hfs location> <(Writable) configuration hfs location> <userid> <password>"  
   exit 0
fi
 

InstallRoot=$1
ConfigRoot=$2

echo "InstallRoot = $InstallRoot"
echo "ConfigRoot = $ConfigRoot" 

if [ ! -d $InstallRoot ]
then
   echo "$InstallRoot is not a valid directory"
   echo "Usage Syntax: ${0} <install hfs location> <(Writable) configuration hfs location>"
   exit 0
fi

if [ ! -d $ConfigRoot ]
then
   echo "$ConfigRoot is not a valid directory"
   echo "Usage Syntax: ${0} <install hfs location> <(Writable) configuration hfs location>"
   exit 0
fi

if [ ! -w $ConfigRoot ]
then
   echo "$ConfigRoot must be writable"
   echo "Usage Syntax: ${0} <install hfs location> <(Writable) configuration hfs location>"
   exit 0
fi


if [ ! -e $ConfigRoot/profiles/default/bin/setupCmdLine.sh ]
then
   echo "The Configuration HFS location specified is invalid. $ConfigRoot/profiles/default/bin/setupCmdLine.sh does not exist!"
   exit 8
fi

. $ConfigRoot/profiles/default/bin/setupCmdLine.sh

if [ ! -e $ConfigRoot/properties/WXDOP ]
then 
  echo "Runing the linkXD700opszOSImageND7.sh installedHFS ConfigHFS"
        $InstallRoot/bin/linkXD700opszOSImageND7.sh  $InstallRoot $ConfigRoot
        rc=$?
	if [ rc -ne 0 ]
        then
                echo "linkXD700opszOSImageND7.sh  has failed!"
        fi
       
        echo "Upgrade to server.xml to 64 bit"
        $ConfigRoot/bin/ws_ant.sh  -file $InstallRoot/profileTemplates/xd_augment/actions/upgradeto64bit.ant -DWAS_HOME=$ConfigRoot
        rc=$?
	if [ rc -ne 0 ]
        then
                echo "upgradeto64bit.ant has failed!"
        fi

        echo "Upgrade postInstaller Links: " 
              $InstallRoot/profileTemplates/xd_augment/actions/upgradepostInstallerlinksVE700.sh $InstallRoot $ConfigRoot 

        rc=$?
	if [ rc -ne 0 ]
        then
                echo "upgradepostInstallerlinksVE700.sh has failed!"
        fi
   

       
        if [ $CONFIG_TYPE = DMGR ]
        then
		  echo "Updating the config and remove the node metadata properties" 
		  $ConfigRoot/bin/ws_ant.sh  -file $InstallRoot/profileTemplates/xd_augment/actions/copyMigratedConfigChanges.ant -DWAS_HOME=$ConfigRoot -DInstallRoot=$InstallRoot
		  if [ rc -ne 0 ]
		  then
			echo "Updating the config changes and remove the node metadata properties was not successful"
		  else
			echo "successfully updated the config to remove the CG and DG properties"
		  fi
          echo "Configuring the Deployment Manager"
          $ConfigRoot/profiles/default/bin/iscdeploy.sh -restore
          rc=$?
          if [ rc -ne 0 ]
             then
                echo "iscdeploy.sh has failed!"
          fi
         else 
            echo "Configuring the AppServer Node"
          if [ -z $3 ]
           then
              $ConfigRoot/profiles/default/bin/ejosync.sh $ConfigRoot
           else 
              $ConfigRoot/profiles/default/bin/ejosync.sh $ConfigRoot $3 $4
           fi
           rc=$?
           if [ rc -ne 0 ]
           then
                echo "ejosync.sh has failed!"
           fi

        fi

  echo "Successfully updated the links for WebSphere Virtual Enterprise"
  
   
else

   echo "WebSphere VE Operations packages is not installed"
        
fi  

  

exit 0 
